<app-loading *ngIf="isLoading"></app-loading>
<div class="content">
  <mb-button mbButtonType="NO_BORDER" mbButtonSize="LARGE" (click)="navigateRateEmployeeResult()"
             mbButtonText="Đánh giá toàn bộ" mbButtonAvailableStyle="PRIMARY"
             *ngIf="objFunction?.view">
  </mb-button>
  <mb-button mbButtonSize="MEDIUM" mbButtonText="Tải dữ liệu lên" mbButtonTextColor="#141ED2"
      (click)="showModalUploadFile(footerTmplUploadFile)" *ngIf="objFunction?.import">
  </mb-button>
<!--  <mb-button *ngIf="objFunction?.download" mbButtonType="NO_BORDER" mbButtonSize="LARGE"-->
<!--             mbButtonText="{{'export' | translate}}" mbButtonAvailableStyle="PRIMARY">-->
<!--  </mb-button>-->
  <mb-button mbButtonType="NO_BORDER" mbButtonSize="LARGE" (click)="save()" *ngIf="objFunction?.create"
             mbButtonText="{{'common.button.save' | translate}}" mbButtonAvailableStyle="PRIMARY">
  </mb-button>
</div>
<ng-template #footerTmplUploadFile>
  <section class="flex-footer__uploadfile">
    <mb-button mbButtonType="NO_BORDER" mbButtonSize="VERY_LARGE" (click)="modalRef.getContentComponent().save()"
      mbButtonAvailableStyle="PRIMARY" mbButtonText="{{'targerManager.button.btnSaveFile' | translate}}"></mb-button>
    <mb-button mbButtonAvailableStyle="BtnCancelHasBorder"
      mbButtonText="{{'targerManager.button.btnCancel' | translate}}" (click)="modalRef.destroy()"
      *ngIf="objFunction?.view" class="flex-footer__uploadfile--button-left"></mb-button>
  </section>
</ng-template>

<form-search-employee-component
  [isJanuary]="true"
  [IsAssessmentTime]="true" (getListSearchDataEmployee)="receiveDataEmployee($event)"
  (onLoading)="onLoading($event)">
</form-search-employee-component>



  <nz-table #basicTable [nzData]="listDataEmployeeIndicator" class="data-table ant-table-content" nzSize="small"
            [nzScroll]="listDataEmployeeIndicator?.length > 2 ? { x: '1366px', y: '500px' }: {}"
            [nzWidthConfig]="listWidth"
            [nzShowPagination]="false"
            nzTableLayout="fixed"
  >
    <thead>
      <tr>
        <th id='index' class="text-nowrap text-center">{{'targerManager.table.stt' | translate}}</th>
        <th id='codeEmploy'>{{'targerManager.employTargetList.label.codeEmploy' | translate}}</th>
        <th id='fullname'>{{'targerManager.employTargetList.label.fullname' | translate}}</th>
        <th id='setOfIndicatorsName'>{{'targerManager.setOfIndicators.label.table.setOfIndicatorsName' | translate}}</th>
        <th id='position'>{{'targerManager.setOfIndicators.label.table.position' | translate}}</th>
        <th scope="col">{{'targerManager.setOfIndicators.label.table.fromDate' | translate}}</th>
        <th scope="col">{{'targerManager.setOfIndicators.label.table.toDate' | translate}}</th>
        <th id='flagStatus'>{{'targerManager.setOfIndicators.label.table.flagStatus' | translate}}</th>
        <th id='density'>{{'targerManager.employTargetList.label.density' | translate}}</th>
        <th id='resultNum'>{{'targerManager.EvaluetionApprovalSetOfIndicator.label.resultNum' | translate}}</th>
        <th id='scoreTotal'>{{'targerManager.targetAssessmentResults.label.table.scoreX' | translate}}</th>
        <th id='plusPoint'>{{'targerManager.EvaluetionApprovalSetOfIndicator.label.plusPoint' | translate}}</th>
        <th id='minusPoint'>{{'targerManager.EvaluetionApprovalSetOfIndicator.label.minusPoint' | translate}}</th>
        <th id='pivotPoint'>{{'targerManager.EvaluetionApprovalSetOfIndicator.label.pivotPoint' | translate}}</th>
        <th id='operation' nzRight></th>
      </tr>
    </thead>
    <tbody *ngIf="listDataEmployeeIndicator.length > 0">

      <tr [ngClass]="{'hightlight-text ': employee.isRejected && (employee.flagStatus === processFlagStatus.CHUA_GUI_XAC_NHAN_KQ)}" *ngFor="let employee of listDataEmployeeIndicator; let i = index;trackBy: trackByFn;" (dblclick)="redrirectToDetail(employee)">
        <ng-container>
          <td class="text-center">{{i+1}}</td>
          <td>{{employee?.empCode}}</td>
          <td>{{employee?.fullName}}</td>
          <td>{{employee?.sotName}}</td>
          <td>{{employee?.posName}}</td>
          <td>{{employee?.asmFromDate | date: 'dd/MM/yyyy'}}</td>
          <td>{{employee?.asmToDate | date: 'dd/MM/yyyy'}}</td>
          <td>
            <nz-tag [nzColor]="'blue'" *ngIf="employee?.flagStatus === processFlagStatus.CHUA_GUI_XAC_NHAN_GIAO">
              {{'targerManager.common.notification.tranctionHasnotbeenSent' | translate}}</nz-tag>
            <nz-tag [nzColor]="'blue'" *ngIf="employee?.flagStatus === processFlagStatus.CHO_XAC_NHAN_GIAO">
              {{'targerManager.common.notification.waitingForDeliveryConfirmation' | translate}}</nz-tag>
            <nz-tag [nzColor]="'blue'" *ngIf="employee?.flagStatus === processFlagStatus.CHO_PHE_DUYET_GIAO">
              {{'targerManager.common.notification.waitingForDeliveryApproval' | translate}}</nz-tag>
            <nz-tag [nzColor]="'blue'" *ngIf="employee?.flagStatus === processFlagStatus.HOAN_TAT_PHE_DUYET_GIAO">
              {{'targerManager.common.notification.completeTheDeliveryApproval' | translate}}</nz-tag>
            <nz-tag [nzColor]="'blue'" *ngIf="employee?.flagStatus === processFlagStatus.CHUA_GUI_XAC_NHAN_KQ">
              {{'targerManager.common.notification.haventSentConfirmationOfKQ' | translate}}</nz-tag>
            <nz-tag [nzColor]="'blue'" *ngIf="employee?.flagStatus === processFlagStatus.CHO_XAC_NHAN_KQ">
              {{'targerManager.common.notification.waitingForConfirmationOfKQ' | translate}}</nz-tag>
            <nz-tag [nzColor]="'blue'" *ngIf="employee?.flagStatus === processFlagStatus.CHO_PHE_DUYET_KQ">
              {{'targerManager.common.notification.waitingForResultsApproval' | translate}}</nz-tag>
            <nz-tag [nzColor]="'blue'" *ngIf="employee?.flagStatus === processFlagStatus.HOAN_TAT_PHE_DUYET_KQ">
              {{'targerManager.common.notification.finalizationOfResultsApproval' | translate}}</nz-tag>
          </td>
          <td class="text-right">
            <mb-input-text (dblclick)='$event.stopPropagation()'
                           [(ngModel)]='employee.scaleNum'
                           (mbChange)="onChange($event, employee)"
                           [mbDisable]="+employee.scaleNum === 100 || (employee?.flagStatus === processFlagStatus.CHO_PHE_DUYET_KQ && employee?.logic === 0)"
                           [mbType]="isSubmitted && (employee.invalid || !employee.scaleNum || employee.scaleNum > 100 || employee.scaleNum < 0) ? 'error' : 'default'"
                           [mbShowError]='isSubmitted && (employee.invalid || !employee.scaleNum || employee.scaleNum > 100 || employee.scaleNum < 0)'
                           [mbErrors]="{invalidScale: isSubmitted && (employee.invalid),
                                        require: isSubmitted && !employee.scaleNum,
                                        limitScale: isSubmitted && employee.scaleNum > 100,
                                        limitScaleMin: isSubmitted && employee.scaleNum < 0}"
                           [mbErrorDefs]="[
                            { errorName: 'invalidScale', errorDescription: 'targerManager.validate.isNotDecimal' | translate: {'param': 'targerManager.targetAssessmentResults.label.table.density' | translate }},
                            { errorName: 'require', errorDescription: 'targerManager.validate.required' | translate: {'param': 'targerManager.targetAssessmentResults.label.table.density' | translate }},
                            { errorName: 'limitScale', errorDescription: 'targerManager.validate.maxOne' | translate: {'param': 'targerManager.targetAssessmentResults.label.table.density' | translate }},
                            { errorName: 'limitScaleMin', errorDescription: 'targerManager.validate.minOne' | translate: {'param': 'targerManager.targetAssessmentResults.label.table.density' | translate }},
                            ]"
                           mbPlaceholderText="{{'targerManager.employTargetList.label.density' | translate}}"
                           [mbShowFlexEnd]="false">
            </mb-input-text>
          </td>
          <td class="text-right">{{employee?.resultNum | formatScore}}</td>
          <td class="text-bold text-right border-left" [rowSpan]="employee.rowSpan" *ngIf="employee?.index">{{employee?.totalResultNum | formatScore}}</td>
          <td class="text-right" [rowSpan]="employee.rowSpan" *ngIf="employee?.index">{{employee?.plusPoint | formatScore}}</td>
          <td class="text-right" [rowSpan]="employee.rowSpan" *ngIf="employee?.index">{{employee?.minusPoint | formatScore}}</td>
          <td class="text-right border-right" [rowSpan]="employee.rowSpan" *ngIf="employee?.index">{{employee?.resultFinal | formatScore}}</td>
          <td [class.action-plan.action-plan]="employee?.flagStatus === processFlagStatus.CHO_PHE_DUYET_KQ" class='pt-2em' nzRight>
            <!-- correction -->
            <mb-button mbButtonType="BORDER"
              *ngIf="employee?.flagStatus === processFlagStatus.HOAN_TAT_PHE_DUYET_KQ && employee?.managerId === currentUser?.empCode && objFunction?.edit"
              mbButtonSize="SMALL" (click)="showModalCorrectionPlan(employee, $event)" mbButtonAvailableStyle="PRIMARY"
              mbButtonText="{{'targerManager.employTargetList.label.correction' | translate}}">
            </mb-button>
            <!-- end correction -->

            <mb-button mbButtonType="BORDER"
              *ngIf="employee?.flagStatus === processFlagStatus.CHUA_GUI_XAC_NHAN_KQ && employee?.managerId === currentUser?.empCode && objFunction?.edit"
              mbButtonSize="SMALL" (click)="confirmApprove(employee, $event)" mbButtonAvailableStyle="PRIMARY"
              mbButtonText="{{'targerManager.employTargetList.label.sendEmployee' | translate}}">
            </mb-button>

            <!-- approved and reject employee -->
            <div nz-row [nzGutter]="[16, 16]" *ngIf="employee?.flagStatus === processFlagStatus.CHO_PHE_DUYET_KQ && employee?.logic === 0 && objFunction?.approve">
              <div nz-col [nzXl]="{ span: 24 }" [nzXXl]="{ span: 12 }">
                <mb-button mbButtonType="NO_BORDER" mbButtonSize="LARGE" (click)="approvePlanAssignment(employee, $event)"
                           mbButtonText="{{'targerManager.table.action.yes' | translate}}" mbButtonAvailableStyle="PRIMARY"></mb-button>
              </div>
              <div nz-col [nzXl]="{ span: 24 }" [nzXXl]="{ span: 12 }">
                <mb-button mbButtonType="NO_BORDER" mbButtonSize="LARGE" (click)="showModalRejectPlan(employee, $event)"
                           mbButtonText="{{'targerManager.table.action.no' | translate}}" mbButtonAvailableStyle="PRIMARY"></mb-button>
              </div>
            </div>
          </td>
        </ng-container>
      </tr>
    </tbody>
  </nz-table>
<!--reject evaluation approval-->
<mb-modal-confirm #modalCompReject
                  [modalHeader]="'Từ chối giá trị giao kế hoạch'"
                  [isVisibleCorrectionDialog]='false'
                  (sendApprovedValid)='rejectPlanAssignment($event)'
                  [mbErrorDefs]="[
          { errorName: 'maxlength', errorDescription: 'goaManagement.validate.maxLength' | translate: {'numberLength': '250' }},
          { errorName: 'required', errorDescription: 'goaManagement.validate.required' | translate: {'param': 'targerManager.personalTargetList.label.table.reasonReject' | translate }},
          { errorName: 'noAllowSpace', errorDescription: 'goaManagement.validate.required' | translate: {'param': 'targerManager.personalTargetList.label.table.reasonReject' | translate }}]"
                  mbPlaceholderText="{{'targerManager.personalTargetList.label.table.inputReasonReject' | translate}}"
                  titleInputText="{{'targerManager.personalTargetList.label.table.inputReasonReject' | translate}}">
  >
</mb-modal-confirm>
<!--correction evaluation approval-->
<mb-modal-confirm #modalCompCorrection
                  [modalHeader]="'Hiệu chỉnh giá trị giao kế hoạch'"
                  [isVisibleCorrectionDialog]='false'
                  (sendApprovedValid)='correctionPlanAssignment($event)'
                  [mbErrorDefs]="[
          { errorName: 'maxlength', errorDescription: 'goaManagement.validate.maxLength' | translate: {'numberLength': '250' }},
          { errorName: 'required', errorDescription: 'goaManagement.validate.required' | translate: {'param': 'targerManager.EvaluetionApprovalSetOfIndicator.label.correctionReason' | translate }},
          { errorName: 'noAllowSpace', errorDescription: 'goaManagement.validate.required' | translate: {'param': 'targerManager.EvaluetionApprovalSetOfIndicator.label.correctionReason' | translate }}]"
                  mbPlaceholderText="{{'targerManager.EvaluetionApprovalSetOfIndicator.label.correctionReason' | translate}}"
                  titleInputText="{{'targerManager.EvaluetionApprovalSetOfIndicator.label.correctionReason' | translate}}">
>
</mb-modal-confirm>
